/*
 * grWinInt.h --
 *
 * Internal definitions for grWinsu[1..5].c.
 *
 * NOTE:  In order for the these defs to work correctly, this file
 * (grXInt.h) must be included after all the Magic .h files and before
 * the X .h files.
 */

/* Constants
 */
#define M_WIDTH		1023
#define M_HEIGHT	750

#define MAX_CURSORS	32	/* Maximum number of programmable cursors */

#define WIN_BATCH_SIZE	10000

#define true		1
#define false		0

#undef TRUE

#define grMagicToWin(y) ( grCurrent.mw->w_allArea.r_ytop - (y))
#define grWinToMagic(y) ( grCurrent.mw->w_allArea.r_ytop - (y))

/* Macro for conversion between X and Magic coordinates
 */

/* Current settings for X function parameters */
typedef struct {
    HFONT 		font;
    HCURSOR		cursor;
    int			fontSize;
    int			depth;
    int			maskmod;
    HWND 		window;
    MagWindow		*mw;
} GR_CURRENT;

extern HINSTANCE pInstance;
extern int gCmdShow;
extern HPALETTE grWinpalette;
extern HPEN grPenDraw, grPenCopy, grPenGlyph;
extern HBRUSH grBrushFill, grBrushText;
extern HDC hdc;
extern COLORREF grPixels[];

extern unsigned long grPlanes[];
extern GR_CURRENT grCurrent;

extern bool grwinGetCursorPos();
extern bool grwinDrawGrid();
extern Void GrWinEnableTablet();
extern Void GrWinDisableTablet();
extern Void GrWinSetCMap();
extern Void grwinPutText();
extern Void grwinDefineCursor();
extern Void GrWinSetCursor();
extern Void GrWinTextSize();
extern Void GrWinDrawGlyph();
extern Void GrWinBitBlt();
extern Void NullBitBlt();
extern int  GrWinReadPixel();
extern Void grwinDrawLine();
extern Void grwinSetLineStyle();
extern Void grwinSetCharSize();
extern Void grwinSetWMandC();
extern Void grwinFillRect();
extern Void grwinRectConvert();
#ifdef NONMANHATTAN
extern Void grwinFillPolygon();
#endif

extern Void grwinDrawLines();
extern int grwinNbLines;

extern POINT grwinLines[];
extern RECT grwinRects[];

extern LRESULT CALLBACK ParseMessage(HWND, UINT, WPARAM, LPARAM);

#define GR_WIN_FLUSH_LINES() {if (grwinNbLines>0) {grwinDrawLines(grwinLines, grwinNbLines); grwinNbLines=0;}}
#define	GR_WIN_FLUSH_BATCH() GR_WIN_FLUSH_LINES()
